<?php

if(isset($_POST['status'])){
    $status = $_POST['status'];
}else{
    $status = 'publish';
}

if(!empty($_POST['sort_field'])){
    $sort_field = $_POST['sort_field'];
}else{
    $sort_field = 'id';
}
if(!empty($_POST['start'])){
    $start = $_POST['start'] - 1;
}else{
    $start = 0;
}

if(!empty($_POST['end'])){
    $end = $_POST['end'] + 1;
}else{
    $end = $_POST['max'] + 1;
}

if($start > $_POST['max']){
    $start = $_POST['max'];
}

if($end > $_POST['max']){
    $end = $_POST['max'] + 1;
}

$range = " WHERE {$sort_field} > {$start} && {$sort_field} < {$end}";



    $DB_HOST = get_option($mac_pfd_db_host_pfd_fn);
    $DB_NAME = get_option($mac_pfd_db_name_pfd_fn);
    $DB_USER = get_option($mac_pfd_db_username_pfd_fn);
    $DB_PASS = get_option($mac_pfd_db_password_pfd_fn);
    $DB_TABLE = get_option($mac_pfd_db_table_pfd_fn);
    $TITLE_FIELD = get_option($mac_pfd_db_title_field_fn);
    $BODY_FIELD = get_option($mac_pfd_db_body_field_fn);
    $IMAGE_FIELD = get_option($mac_pfd_db_image_field_fn);
    $URL_FIELD = get_option($mac_pfd_db_url_field_fn);
    $DATE_FIELD = get_option($mac_pfd_db_date_field_fn);
    $CATEGORY_FIELD = get_option($mac_pfd_db_category_field_fn);
    $SIZE_FIELD = get_option($mac_pfd_db_size_field_fn);
    $TYPE_FIELD = get_option($mac_pfd_db_type_field_fn);

// Connect to database    
try{
$DBH = new PDO("mysql:host=$DB_HOST;dbname=$DB_NAME", $DB_USER, $DB_PASS);
}
 catch (PDOException $e){
}

$DBH->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

// Selects rows from the specified table based on Start and End Record inputs
$STH = $DBH->query("SELECT * FROM ".$DB_TABLE.$range);
$STH->setFetchMode(PDO::FETCH_ASSOC);


$processed = 0; // 
$skipped = 0; // 

while($row = $STH->fetch()){
    $raw_title = $row[$TITLE_FIELD];
    $title = html_entity_decode($raw_title);
    $body = html_entity_decode($row[$BODY_FIELD]);
    $post_date = $row[$DATE_FIELD]." 17:51:00";
    

    // Check for duplicate
    if(!get_page_by_title($raw_title, 'OBJECT', 'post')){
    //

        $category = $row[$CATEGORY_FIELD];
        $cat_id = get_cat_ID($category);

        // Set up the value for the custom field 'enclosure' for PowerPress
        $enclosure_value = $row[$URL_FIELD];
        $enclosure_value .= "\n";
        $enclosure_value .= $row[$SIZE_FIELD];
        $enclosure_value .= "\n";
        $enclosure_value .= $row[$TYPE_FIELD];

        // Set up the Post
        $post = array(
            'post_category' => array($cat_id),
            'post_content' => $body,
            'post_date' => $post_date,
            'post_title' => $title,
            'post_type' => 'post',
            'post_status' => $status,
        );

        // If the Post is successfully inserted the new Post_id will be returned
        // then use post id to handle image
        if($post_id = wp_insert_post($post)){

            $image_url = $row[$IMAGE_FIELD];
            if($image_url !== NULL){
                $upload_dir = wp_upload_dir();
                $image_data = file_get_contents($image_url);
                $filename = basename($image_url);
                if(wp_mkdir_p($upload_dir['path']))
                    $file = $upload_dir['path'] . '/' . $filename;
                else
                    $file = $upload_dir['basedir'] . '/' . $filename;
                file_put_contents($file, $image_data);

                $wp_filetype = wp_check_filetype($filename, null );
                $attachment = array(
                    'post_mime_type' => $wp_filetype['type'],
                    'post_title' => sanitize_file_name($filename),
                    'post_content' => '',
                    'post_status' => 'inherit'
                );
                $attach_id = wp_insert_attachment( $attachment, $file, $post_id );
                require_once(ABSPATH . 'wp-admin/includes/image.php');
                $attach_data = wp_generate_attachment_metadata( $attach_id, $file );
                wp_update_attachment_metadata( $attach_id, $attach_data );

                set_post_thumbnail( $post_id, $attach_id );
                update_post_meta($post_id, 'enclosure', $enclosure_value);

            }
            $processed++;
    }
  }else{
      $skipped++;
  }
}

echo '<div class="updated"><p><strong>';

if(($start + 1) > ($end - 1)){
    echo '<h3><strong>';
    echo __('Please verify your Start and End Record range', 'powerpress-posts-from-mysql');
    echo ':&nbsp;'.$sort_field."'s&nbsp;".($start + 1).'&nbsp;-&nbsp;'.($end - 1);
    echo '</strong></h3></p><p>';
}else{
    printf(_n('%d podcast posted.', '%d podcasts posted.', $processed, 'powerpress-posts-from-mysql'), $processed);
    echo '<br />';
    printf(_n('%d podcast skipped as duplicate.', '%d podcasts skipped as duplicates.', $skipped, 'powerpress-posts-from-mysql'), $skipped);
    echo '</strong></p><p>';
    printf(__('Podcast %s numbers: %d through %d', 'powerpress-posts-from-mysql'), $sort_field, $start + 1, $end - 1);
    echo '</p><p>';
    printf(__('Status: %s', 'powerpress-posts-from-mysql'), $status);
    echo '</p>';
}
echo '</div>';